Codeforces#385C_素数打表+dp

来源:互联网 发布:java常用api总结 编辑:程序博客网 时间:2024/05/22 20:19

素数打表方法

void init_prim(){    memset(vis,1,sizeof(vis));    for(int i=2; i<=MM; i++)    {        if(vis[i])        {            for(int j=i*2; j<=MM; j+=i)                vis[j]=0;        }    }}

Codeforces#385C Bear and Prime Numbers

Recently, the bear started studying data structures and faced the following problem.

You are given a sequence of integers x1, x2, …, xn of length n and m queries, each of them is characterized by two integers li, ri. Let’s introduce f(p) to represent the number of such indexes k, that xk is divisible by p. The answer to the query li, ri is the sum: , where S(li, ri) is a set of prime numbers from segment [li, ri] (both borders are included in the segment).

Help the bear cope with the problem.

Input

The first line contains integer n (1 ≤ n ≤ 106). The second line contains n integers x1, x2, …, xn (2 ≤ xi ≤ 107). The numbers are not necessarily distinct.

The third line contains integer m (1 ≤ m ≤ 50000). Each of the following m lines contains a pair of space-separated integers, li and ri (2 ≤ li ≤ ri ≤ 2·109) — the numbers that characterize the current query.

Output

Print m integers — the answers to the queries on the order the queries appear in the input.

Sample Input

Input
6
5 5 7 10 14 15
3
2 11
3 12
4 4
Output
9
7
0
Input
7
2 3 5 7 11 4 8
2
8 10
2 123
Output
0
7

Hint

Consider the first sample. Overall, the first sample has 3 queries.

The first query l = 2, r = 11 comes. You need to count f(2) + f(3) + f(5) + f(7) + f(11) = 2 + 1 + 4 + 2 + 0 = 9.
The second query comes l = 3, r = 12. You need to count f(3) + f(5) + f(7) + f(11) = 1 + 4 + 2 + 0 = 7.
The third query comes l = 4, r = 4. As this interval has no prime numbers, then the sum equals 0.


题解

1)素数快速打表法,列举0-最大值之间的素数。

2)因为素数快速打表的内循环,即

 for(int j=i*2; j<=MM; j+=i)      {         vis[j]=0;      }

j的值,即为能被素数i整除的数(除此之外,还要加上i本身),所以就能计算出每个素数能整除的数的个数,记为dp[i];

3)解为dp[r]-dp[l-1]。

# include<iostream># include<cstdio># include<cstring># include<algorithm># include<cmath>using namespace std;const int MM=1e7+10;int cnt[MM+5],dp[MM+5],vis[MM+5];void init_prim(){    memset(vis,1,sizeof(vis));    for(int i=2; i<=MM; i++)    {        if(vis[i])        {            if(cnt[i])dp[i]+=cnt[i];            for(int j=i*2; j<=MM; j+=i)            {                if(cnt[j])dp[i]+=cnt[j];                vis[j]=0;            }        }    }    for(int i=1; i<=MM; i++)        dp[i]+=dp[i-1];}int main(){    int n,a,r,l,m;    memset(cnt,0,sizeof(cnt));    memset(dp,0,sizeof(dp));    scanf("%d",&n);    for(int i=0; i<n; i++)    {        scanf("%d",&a);        cnt[a]++;    }    init_prim();    scanf("%d",&m);    while(m--)    {        scanf("%d%d",&l,&r);        r=r>MM?MM:r;        l=l>MM?MM:l;        printf("%d\n",dp[r]-dp[l-1]);    }    return 0;}
0 0
原创粉丝点击